<template>
    <div class="container-fluid">
        <div class="block-header">
            <a class="btn btn-primary waves-effect" @click="senderPage('addSubCategory')">
                <i class="material-icons">add</i>
                <span>Add New Category</span>
            </a>
        </div>
        <!-- Exportable Table -->
        <div class="row clearfix">
            <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                <div class="card">
                    <div class="header">
                        <h2>
                            ALL SUB-CATEGORIES
                            <span class="badge bg-blue"></span>
                        </h2>
                    </div>
                    <div class="body">
                        <div class="table-responsive">
                            <table class="table table-bordered table-striped table-hover dataTable js-exportable">
                                <thead>
                                <tr>
                                    <th>SL</th>
                                    <th>Category Name</th>
                                    <th>Sub-Category Name</th>
                                    <th>Total Items</th>
                                    <th>Updated At</th>
                                    <th>Action</th>
                                </tr>
                                </thead>
                                <tfoot>
                                <tr>
                                    <th>SL</th>
                                    <th>Category Name</th>
                                    <th>Sub-Category Name</th>
                                    <th>Total Items</th>
                                    <th>Updated At</th>
                                    <th>Action</th>
                                </tr>
                                </tfoot>
                                <tbody>
                                <tr v-for="(subCategory,key) in subCategories" :key="subCategory.id">
                                    <td>
                                        {{key+1}}
                                    </td>
                                    <td>
                                        <p v-for="category in subCategory.categories" :key="category.id">{{category.name}},</p>
                                    </td>
                                    <td>{{subCategory.name}}</td>
                                    <td>{{subCategory.products.length}}</td>
                                    <td>{{ moment(subCategory.updated_at).format('D-M-Y hh:mm a') }}</td>
                                    <td class="text-center">
                                        <a @click="edit(subCategory)" href="javascript:void(0)" class="btn btn-info waves-effect">
                                            <i class="material-icons">edit</i>
                                        </a>
                                        <button class="btn btn-danger waves-effect" type="button" @click="deleteCategory(subCategory.id)">
                                            <i class="material-icons">delete</i>
                                        </button>
                                    </td>
                                </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- #END# Exportable Table -->
    </div>

</template>
<script>
import moment from "moment";
    export default {
        data(){
            return {
                moment,
                subCategories:{},
            }
        },
        created(){
            this.getInfo();
        },
        updated(){
            this.getInfo();
        },
        mounted() {
            const plugin = document.createElement("script");
            plugin.setAttribute(
                "src",
                "https://unpkg.com/sweetalert2@7.19.1/dist/sweetalert2.all.js"
            );
            plugin.async = true;
            document.head.appendChild(plugin);
        },
        methods:{
            getInfo(){
                axios.get('/admin/sub/category').then((response)=>{
                    this.subCategories=response.data;
                });
            },
            senderPage(text){
                this.$emit('sent',text);
            },
            edit(text){
                this.$emit('edit',text);
                //console.log(data);
            },
            deleteCategory(subCategory) {
                swal({
                    title: 'Are you sure?',
                    text: "You won't be able to revert this!",
                    type: 'warning',
                    showCancelButton: true,
                    confirmButtonColor: '#3085d6',
                    cancelButtonColor: '#d33',
                    confirmButtonText: 'Yes, delete it!',
                    cancelButtonText: 'No, cancel!',
                    confirmButtonClass: 'btn btn-success',
                    cancelButtonClass: 'btn btn-danger',
                    buttonsStyling: false,
                    reverseButtons: true
                }).then((result) => {
                    if (result.value) {
                        axios.delete(`/admin/sub/category/delete/${subCategory}`).then((response)=>{
                            if(response.data[0]===0){
                                this.$toaster.error(response.data[1]);
                            }
                            else{
                                this.$toaster.success(response.data[1]);
                                this.getInfo();
                            }
                        });
                    } else if (
                        // Read more about handling dismissals
                        result.dismiss === swal.DismissReason.cancel
                    ) {
                        swal(
                            'Cancelled',
                            'Your data is safe :)',
                            'error'
                        )
                    }
                })
            },
        }
    }
</script>

